import { OnInit, OnDestroy } from '@angular/core';
import { NgxSelect2ExService } from '../../services/ngx-select2-ex.service';
import { NgxSelect2ExOptionHandler } from '../../classes/ngx-select2-ex-option-handler';
import { NgxSelect2ExLanguageInputs } from '../../classes/ngx-select2-ex-language-inputs';
import { NgxSelect2OptionFilterPipe } from '../../pipes/ngx-select2-option-filter.pipe';
export declare class NgxSelect2ExDropdownComponent implements OnInit, OnDestroy {
    private filterPipe;
    service: NgxSelect2ExService;
    multi: boolean | null;
    theme: string;
    minimumResultsForSearch: number;
    minimumInputLength: number | null;
    maximumInputLength: number | null;
    language: NgxSelect2ExLanguageInputs;
    display: string;
    position: string;
    top: any;
    left: any;
    right: any;
    width: any;
    options: Array<NgxSelect2ExOptionHandler>;
    search: string;
    private subscriptions;
    constructor(filterPipe: NgxSelect2OptionFilterPipe);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onOptionHover(hoveredOption: NgxSelect2ExOptionHandler): void;
    onOptionClick(clickedOption: NgxSelect2ExOptionHandler): void;
    getContainerThemeClass(): string;
    shouldHideSearchBox(): boolean;
    getNoResultsMessage(): string;
    getInputTooShortMessage(): string;
    getInputTooLongMessage(): string;
    shouldShowNoResultsMessage(): boolean;
    shouldShowInputTooShortMessage(): boolean;
    shouldShowInputTooLongMessage(): boolean;
    private subscribeToOptions();
    private subscribeToDropdownPositionChanges();
    private subscribeToSearchChanges();
    private initDropdownPosition(dropdownPosition);
    private selectOnClose();
    private unsubscribe();
}
