import { OnInit, OnChanges, SimpleChanges, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NgxSelect2ExOptionHandler } from '../../classes/ngx-select2-ex-option-handler';
import { NgxSelect2ExService } from '../../services/ngx-select2-ex.service';
import { INgxSelect2ExLanguageInputs } from '../../interfaces/ngx-select2-ex-language-inputs';
import { INgxSelect2ExOption } from '../../interfaces/ngx-select2-ex-option';
export declare class NgxSelect2ExComponent implements OnInit, OnChanges, OnDestroy, ControlValueAccessor {
    ngxSelect2ExService: NgxSelect2ExService;
    options: Array<INgxSelect2ExOption> | Array<string> | null;
    disabled: boolean | null;
    multi: boolean | null;
    theme: string | null;
    minimumResultsForSearch: number | null;
    minimumInputLength: number | null;
    maximumInputLength: number | null;
    language: INgxSelect2ExLanguageInputs | null;
    selectOnClose: boolean | null;
    closeOnSelect: boolean | null;
    allowClear: boolean;
    placeholder: string | null;
    isOpen: boolean;
    isInFocus: boolean;
    selection: Array<NgxSelect2ExOptionHandler>;
    search: string;
    private subscriptions;
    private propagateChange;
    constructor(ngxSelect2ExService: NgxSelect2ExService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    writeValue(value: Array<INgxSelect2ExOption> | Array<string>): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    getContainerThemeClass(): string;
    getStyleOfSearchListItem(): {
        'width': string;
    };
    getStyleOfInlineInput(search: string): {
        'width': string;
    };
    getInlineInputPlaceholder(): string;
    clearSelection(): void;
    shouldShowClearSelectionButton(): boolean;
    shouldShowPlaceholder(): boolean;
    getTitleTooltipText(): string;
    deselect(optionHandlerToDeselect: NgxSelect2ExOptionHandler): void;
    private subscribeToSelection();
    private subscribeToIsOpen();
    private subscribeToIsInFocus();
    private initOptions(options);
    private isStringList(list);
    private isOptionInterfaceList(list);
    private defaultChangeListener(changes, fieldName);
    private initStaticInputValues();
    private defaultInputSetter(inputField, optionalValue?);
    private unsubscribe();
}
